//package Simulator;

import java.util.*;
public abstract class NetworkConfigure {
  Router [] Routers;
  Link [] Links;
  EventsQueue EQ;
  RouterTable [] RoadTable;
  boolean NeedTraffic = false;  // Link object use it

  // used in class Simulator
  Traffic traffic;
  Random rnd;
  //Pareto pareto;
  //Weibull weibull;

  // used for singlemessMeasurement and MultipleMessMeasurement
  // true means using unitrip time probing
  // false means using roundtrip time probing
  boolean UnitripProbe = false;

  //double msgProcessingTime=0.0001; // 0.1 msec
  double msgProcessingTime=1e-8; // 0.1 msec
  double RouterBandwidth = 1.0E+9;
  double BottleneckLinkBandwidth = 1.0E+7;  // 10MBps
  double LinkBandwidth = 1.0E+8;  // 100MBps
  double signalPropagationSpeed = 2.0E+8;  // fiber speed
  double msgProcessingSpeed= 1.0E+9; //1GBps
  double TBIntervalTime;
  double PBIntervalTime; // Probing Interval Time between two probing cycle

  public abstract void UpdateLog(double update_time);
}
