package Simulator;

/* Pareto distribution (For generating web traffic)
   used for first request generation time and big time gap (between two requests)
   How many references in a web page
*/

class Pareto {

  static public double CDF( double x, double k, double a ) {

    double Fx = 1.0 - Math.pow( k / x,  a );

    return Fx;
  }

  static public double pdf(  double x, double k, double a ) {

    double fx = a * Math.pow( k, a ) * Math.pow( x, -(a + 1) );

    return fx;
  }

  static public double getX( double Fx, double k, double a ) {

   double x = k / Math.pow( ( 1.0 - Fx ), ( 1.0 / a ) );

   return x;
 
  }  
}
