package Simulator;

/* Weibull distribution (For generating web traffic)
   used for time gap (between two references in one web page)
*/

class Weibull {

  static public double CDF( double x, double a, double b ) {

    double Fx = 1.0 - Math.exp( -Math.pow( x / a, b ) );

    return Fx;
  }

  static public double pdf(  double x, double a, double b ) {

    double firstpart = ( b * Math.pow( x, b - 1 ) ) / Math.pow( a, b );
    double power = -Math.pow( x / a, b );
    double secondpart = Math.exp( power ); 
    double fx = firstpart * secondpart;

    return fx;
  }

  public double getX( double Fx, double a, double b ) {


   double x = a * Math.pow( -Math.log( 1 - Fx ), 1.0 / b );
 
   return x;
 
  }  
}
